#ifndef FRAMEBUFFER_H_
#define FRAMEBUFFER_H_

#include <FL/Fl.H>
#include <FL/Fl_Gl_Window.H>


#include "phc.h"

class FrameBuffer : public Fl_Gl_Window {


public:
  unsigned int *pix; // pixel data; one unsigned int per pixel (4 bytes, 32 bits, one byte per channel)
  float *zb; // stores 1/w for visibility
  int w, h; // image resolution
  // virtual methods that you need to implement
  void draw();
  void show();
  int handle(int event);
  FrameBuffer(int u0, int v0, int _w, int _h);
  void Clear(unsigned int clearColor);
  void Set(int u, int v, unsigned int color);
  void Set(FrameBuffer *src, int u0, int v0);
  unsigned int Get(int u, int v);
  void Setf(float uf, float vf, unsigned color);
  void SetGuarded(int u, int v, unsigned int color);
  void MakeChecker(int checkerWidth, unsigned int *colors);
  void DrawPointDiagonalCross(float uf, float vf, 
    int size, unsigned int color);
  void DrawPointSquare(float uf, float vf, 
    int size, unsigned int color);
  void DrawSegment(float u0f, float v0f, float u1f, float v1f,
    unsigned int color);
  void DrawPointDiagonalCross3D(V3& point, PHC &phc, 
    int size, unsigned int color);
  void DrawPointSquare3D(V3& point, PHC &phc,
    int size, unsigned int color);
  void DrawSegment3D(V3 point0, V3 point1, PHC &phc,
    unsigned int color);
  float& ZB(int u, int v);
  void Rotate(PHC& phc0, PHC& phc1, FrameBuffer& I1);
  void RotateFM(PHC& phc0, PHC& phc1, FrameBuffer& I1);
  int Load(char *fname);
  unsigned int GetNorm(float s, float t);
};

#endif