#include "scene.h"
#include <iostream.h>
#include <fstream.h>
#include <float.h>
#include <string.h>
#include "FL/gl.h"

#include "m33.h"

Scene *scene;

Scene::Scene() {

  bbphc = 0;
  cm = 0;
#if 1
  FrameBuffer *ci = new FrameBuffer(10, 10, 10, 10);
  ci->Load("pix/uffizi_cross.tif");
  cm = new CM(ci);
  delete ci;
#endif
  text = new FrameBuffer(0, 0, 1024, 1024);
  unsigned int colors[2] = {0xFFFFFFFF, 0xFF000000};
  text->MakeChecker(2, colors);
  tmeshN = 0;
  int w = 512;
  int h = 512;
  fb = new FrameBuffer(20, 40, w, h);
  fb->label("SW rendering");
  float hfov = 60.0f;
  phc = new PHC(fb->w, fb->h, hfov);
  ui = new GraphAppUI();
  ui->GraphAppW->position(800, 40);

  animationStep = 0;

  // geometry
  tmeshN = 0;
  V3 newCenter;

//  tmesh[0] = new TMesh('q', text);
//  tmeshN = 1;

#if 0
  float maxDim;
  unsigned int color;
  maxDim = 75.0f;
  newCenter =  V3(50.0f, 0.0f, -200.0f);
  color = 0xFF00AAAA;
  tmesh[tmeshN] = new TMesh;
  tmesh[tmeshN]->Load("geo/chess.tris");
  tmesh[tmeshN]->ScaleToMaxDim(maxDim);
  tmesh[tmeshN]->TranslateTo(newCenter);
  tmesh[tmeshN]->SetColor(color);
  tmeshN++;
  
  maxDim = 75.0f;
  newCenter =  V3(0.0f, 0.0f, -100.0f);
  color = 0xFF0000AA;
  tmesh[tmeshN] = new TMesh;
  tmesh[tmeshN]->Load("geo/chess.tris");
  tmesh[tmeshN]->ScaleToMaxDim(maxDim);
  tmesh[tmeshN]->TranslateTo(newCenter);
  tmesh[tmeshN]->SetColor(color);
  tmeshN++;
#endif

  phc2 = 0;

  rstep = 10.0f;
  tstep = tmeshN ? tmesh[0]->FindDiagonal() / 10.0f : 1.0f;

//  phc->Load("mydbg/view.txt");

  CreateBillboard();

  Show();
  Redraw();

}

void Scene::CreateBillboard() {

  return;

  V3 yc = tmesh[0]->FindCenter();
  V3 rc = tmesh[1]->FindCenter();
  V3 vd = (rc-yc).Normalized();
  int bbw = 400, bbh = 400;
  float bfov = 10.0f;
  float d = 4*(rc-yc).Length();
  bbphc = new PHC(bbw, bbh, bfov);
  bbfb = new FrameBuffer(fb->w + 320, 0, bbw, bbh);
  bbfb->Clear(0xFF0090FF);
  bbfb->label("BB");
  bbfb->show();
  float scf = d / bbphc->FocalLength();
  bbphc->a = bbphc->a*scf;
  bbphc->b = bbphc->b*scf;
  bbphc->c = bbphc->c*scf;
  bbphc->UpdateCamMatI();
  bbphc->LookAt(rc, vd, d, V3(0.0f, 1.0f, 0.0f));

}

void Scene::Show() {

  if (fb)
    fb->show();
  if (ui)
    ui->GraphAppW->show();

}

void Scene::UpdateScene() {

  V3 trans(1.0f, 0.0f, 0.0f);
  tmesh[1]->TranslateBy(trans);
  animationStep++;

}

void Scene::Redraw() {

  if (!ui->AnimationB->value()) {
    Render();
    fb->redraw();
    return;
  }

  while (ui->AnimationB->value()) {
    UpdateScene();
    Render();
    fb->redraw();
    Fl::check();
  }

}


void Scene::DBG() {

  phc->Save("mydbg/view.txt");
  return;

  PHC phc1 = *phc;
  FrameBuffer *I1 = new FrameBuffer(0, 0, fb->w, fb->h);
  I1->Clear(0xFF0066FF);
//  phc1.Pan(15.0f);
  float fp = phc1.FocalLength();
  phc1.SetFocalLength(fp*0.1f);
  fb->RotateFM(*phc, phc1, *I1);
  I1->show();
  return;

  V3 point = tmesh[0]->FindCenter(), vd(-1.0f, 0.0f, -1.0f), quasiUp(0.0f, 1.0f, 0.0f);
  float dist = 20.0f;
  vd = vd.Normalized();
  phc2 = new PHC(*phc);
  phc2->LookAt(point, vd, dist, quasiUp);
  Redraw();
  return;

  int neww = fb->w*8/4;
  int newh = fb->h*8/4;
  fb = new FrameBuffer(100, 100, neww, newh);
  fb->label("new resolution");
  fb->show();
  phc->ModifyResolution(neww);
  Redraw();
  return;

  M33 m;
  cerr << m;
  m[1][2] = 13.7f;
  cerr << m;
  return;

  V3 v(3.0f, 4.0f, 5.0f);
  V3 v2(1.0f, -1.0f, 3.0f);
  cerr << "v " << v << endl;
  cerr << "v2 " << v2 << endl;
  cerr << "v+v2 " << v+v2 << endl;
  cerr << "v-v2 " << v-v2 << endl;
  cerr << "v*v2 " << v*v2 << endl;
  cerr << "v length " << v.Length() << endl;
  cerr << "v normalized " << v.Normalized() << endl;

  return;

  if (fb) {
    fb->Clear(0xFFFFFFFF);
    float uf = 150.0f;
    float vf = 200.0f;
    int size = 53;
    fb->DrawPointSquare(uf, vf, size, 0xFF00FF00);
    fb->DrawPointDiagonalCross(uf, vf, size, 0xFF0000FF);
    float u1f = 170.4f;
    float v1f = 301.9f;
    fb->DrawSegment(uf, vf, u1f, v1f, 0xFFFF0000);
    unsigned int colors[2] = {0xFF00FF00, 0xFF0000FF};
    fb->MakeChecker(30, colors);
  }
  Redraw();

}

void Scene::Render() {

  if (!fb)
    return;

  unsigned int bgrColor = 0xFFFFFF00;
  fb->Clear(bgrColor);

  if (bbphc) {
    bbphc->Render(fb, phc, bbphc->FocalLength(), 0xFFFF0000);
    for (int tmi = 1; tmi < tmeshN; tmi++) {
      tmesh[tmi]->RenderFM(bbfb, bbphc);
    }
    bbfb->redraw();
  }

  if (cm) {
    for (int v = 0; v < fb->h; v++) {
      for (int u = 0; u < fb->w; u++) {
        fb->Set(u, v, cm->LookUp(phc->GetRay(u, v)));
      }
    }
  }

  if (phc2) {
    phc2->Render(fb, phc, 60.0f, 0xFFFF0000);
  }

  for (int tmi = 0; tmi < tmeshN; tmi++) {
    tmesh[tmi]->RenderFM(fb, phc);
    break;
  }

  if (bbphc) {
    for (int v = 0; v < fb->h; v++) {
      for (int u = 0; u < fb->w; u++) {
        V3 S = phc->C;
        V3 r = phc->GetRay(u, v);
        V3 Q = bbphc->C + bbphc->c;
        V3 n = bbphc->VD();
        float w = ((Q-S)*n)/(r*n);
        if (w < 0)
          continue;
        V3 P = S + r*w;
        float uf = ((P-Q)*(bbphc->a.Normalized()))/bbphc->a.Length();
        float vf = ((P-Q)*(bbphc->b.Normalized()))/bbphc->b.Length();
        if (uf < 0.0f || uf > (float)bbphc->w)
          continue;
        if (vf < 0.0f || vf > (float)bbphc->h)
          continue;
        fb->Set(u, v, bbfb->Get((int)uf, (int)vf));
      }
    }
  }


  return;


}

void Scene::MouseMove(int u, int v) {

  return;

  if (!fb)
    return;
  fb->DrawPointSquare(.5f+(float)u, .5f+(float)v, 5, 0xFF000000);
  Redraw();

}

void Scene::TranslateForward(float tstep) {

  phc->TranslateForward(tstep);
  Redraw();

}

void Scene::TranslateUp(float tstep) {

  phc->TranslateUp(tstep);
  Redraw();

}

void Scene::TranslateLeft(float tstep) {

  phc->TranslateLeft(tstep);
  Redraw();

}

void Scene::KeyPress(int key) {

    switch (key) {
    case '=': {
      tstep *= 2.0f;
      break;
    }
    case '-': {
      tstep /= 2.0f;
      break;
    }
    case '0': {
      rstep *= 2.0f;
      break;
    }
    case '9': {
      rstep /= 2.0f;
      break;
    }
    case 65362: {
      phc->TranslateForward(tstep);
      break;
    }
    case 65364: {
      phc->TranslateForward(-tstep);
      break;
    }
    case 65361: {
      phc->Pan(rstep);
      break;
    }
    case 65363: {
      phc->Pan(-rstep);
      break;
    }
    case 'w': {
      phc->Tilt(rstep);
      break;
    }
    case 's': {
      phc->Tilt(-rstep);
      break;
    }
    case 'm': {
      phc->Roll(rstep);
      break;
    }
    case 'n': {
      phc->Roll(-rstep);
      break;
    }
    case ',': {
      phc->TranslateLeft(tstep);
      break;
    }
    case '.': {
      phc->TranslateLeft(-tstep);
      break;
    }
    case 'q': {
      phc->TranslateUp(+tstep);
      break;
    }
    case 'a': {
      phc->TranslateUp(-tstep);
      break;
    }
    default:
      break;
  }

  phc->UpdateCamMatI();

  Redraw();

}