#ifndef SCENE_H_

#include "graphAppUI.h"
#include "frameBuffer.h"
#include "phc.h"
#include "v3.h"
#include "tmesh.h"
#include "cubemap.h"

#define SCENE_MAX_TMESH_N 100

class Scene {

  CM *cm;
  GraphAppUI *ui;
  FrameBuffer *fb;
  FrameBuffer *text;
  TMesh *tmesh[SCENE_MAX_TMESH_N];
  int tmeshN;
  PHC *phc, *phc2, *bbphc;
  FrameBuffer *bbfb;
  int animationStep;
  float tstep, rstep;
public:
  Scene();
  void Show();
  void Redraw();
  void MouseRelease(int u, int v);
  void MouseMove(int u, int v);
  void KeyPress(int key);
  void Save();
  void DBG();
  void Render();
  void UpdateScene();
  void TranslateForward(float tstep);
  void TranslateLeft(float tstep);
  void TranslateUp(float tstep);
  void RotateCamera(char axis, float rstep);
  void CreateBillboard();
};

#endif